/* ProcessWatcher.c generated by valac 0.56.17, the Vala compiler
 * generated from ProcessWatcher.vala, do not modify */

/* ProcessWatcher.vala
 *
 * Copyright 2023 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <pqmarble.h>
#include <gio/gio.h>

#define TERMINAL_PROCESS_WATCHER_INTERVAL_MS ((guint) 500)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	TERMINAL_PROCESS_CONTEXT_DEFAULT,
	TERMINAL_PROCESS_CONTEXT_ROOT,
	TERMINAL_PROCESS_CONTEXT_SSH
} TerminalProcessContext;

#define TERMINAL_TYPE_PROCESS_CONTEXT (terminal_process_context_get_type ())

#define TERMINAL_TYPE_PROCESS (terminal_process_get_type ())
#define TERMINAL_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS, TerminalProcess))
#define TERMINAL_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS, TerminalProcessClass))
#define TERMINAL_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS))
#define TERMINAL_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS))
#define TERMINAL_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS, TerminalProcessClass))

typedef struct _TerminalProcess TerminalProcess;
typedef struct _TerminalProcessClass TerminalProcessClass;
typedef struct _TerminalProcessPrivate TerminalProcessPrivate;
enum  {
	TERMINAL_PROCESS_0_PROPERTY,
	TERMINAL_PROCESS_TERMINAL_FD_PROPERTY,
	TERMINAL_PROCESS_PID_PROPERTY,
	TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY,
	TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY,
	TERMINAL_PROCESS_ENDED_PROPERTY,
	TERMINAL_PROCESS_CONTEXT_PROPERTY,
	TERMINAL_PROCESS_NUM_PROPERTIES
};
static GParamSpec* terminal_process_properties[TERMINAL_PROCESS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	TERMINAL_PROCESS_FOREGROUND_TASK_FINISHED_SIGNAL,
	TERMINAL_PROCESS_NUM_SIGNALS
};
static guint terminal_process_signals[TERMINAL_PROCESS_NUM_SIGNALS] = {0};

#define TERMINAL_TYPE_PROCESS_WATCHER (terminal_process_watcher_get_type ())
#define TERMINAL_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcher))
#define TERMINAL_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))
#define TERMINAL_IS_PROCESS_WATCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_IS_PROCESS_WATCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_PROCESS_WATCHER))
#define TERMINAL_PROCESS_WATCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcherClass))

typedef struct _TerminalProcessWatcher TerminalProcessWatcher;
typedef struct _TerminalProcessWatcherClass TerminalProcessWatcherClass;
typedef struct _TerminalProcessWatcherPrivate TerminalProcessWatcherPrivate;
enum  {
	TERMINAL_PROCESS_WATCHER_0_PROPERTY,
	TERMINAL_PROCESS_WATCHER_NUM_PROPERTIES
};
static GParamSpec* terminal_process_watcher_properties[TERMINAL_PROCESS_WATCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

#define TERMINAL_TYPE_SETTINGS (terminal_settings_get_type ())
#define TERMINAL_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettings))
#define TERMINAL_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))
#define TERMINAL_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_TYPE_SETTINGS))
#define TERMINAL_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_TYPE_SETTINGS, TerminalSettingsClass))

typedef struct _TerminalSettings TerminalSettings;
typedef struct _TerminalSettingsClass TerminalSettingsClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block10Data Block10Data;

struct _TerminalProcess {
	GObject parent_instance;
	TerminalProcessPrivate * priv;
};

struct _TerminalProcessClass {
	GObjectClass parent_class;
};

struct _TerminalProcessPrivate {
	gint _terminal_fd;
	GPid _pid;
	GPid _foreground_pid;
	gchar* _last_foreground_task_command;
	gboolean _ended;
	TerminalProcessContext _context;
};

struct _TerminalProcessWatcher {
	GObject parent_instance;
	TerminalProcessWatcherPrivate * priv;
};

struct _TerminalProcessWatcherClass {
	GObjectClass parent_class;
};

struct _TerminalProcessWatcherPrivate {
	GeeArrayList* process_list;
	GeeArrayList* pending_process_list;
	GRecMutex __lock_pending_process_list;
	gboolean watching;
	GThread* loop_thread;
	GMutex mutex;
};

struct _Block10Data {
	int _ref_count_;
	TerminalProcessWatcher* self;
	TerminalProcess* process;
};

static gint TerminalProcess_private_offset;
static gpointer terminal_process_parent_class = NULL;
static gint TerminalProcessWatcher_private_offset;
static gpointer terminal_process_watcher_parent_class = NULL;
static TerminalProcessWatcher* terminal_process_watcher_instance;
static TerminalProcessWatcher* terminal_process_watcher_instance = NULL;

VALA_EXTERN GType terminal_process_context_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType terminal_process_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcess, g_object_unref)
VALA_EXTERN TerminalProcess* terminal_process_new (void);
VALA_EXTERN TerminalProcess* terminal_process_construct (GType object_type);
VALA_EXTERN gint terminal_process_get_terminal_fd (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_terminal_fd (TerminalProcess* self,
                                       gint value);
VALA_EXTERN GPid terminal_process_get_pid (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_pid (TerminalProcess* self,
                               GPid value);
VALA_EXTERN GPid terminal_process_get_foreground_pid (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_foreground_pid (TerminalProcess* self,
                                          GPid value);
VALA_EXTERN const gchar* terminal_process_get_last_foreground_task_command (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_last_foreground_task_command (TerminalProcess* self,
                                                        const gchar* value);
VALA_EXTERN gboolean terminal_process_get_ended (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_ended (TerminalProcess* self,
                                 gboolean value);
VALA_EXTERN TerminalProcessContext terminal_process_get_context (TerminalProcess* self);
VALA_EXTERN void terminal_process_set_context (TerminalProcess* self,
                                   TerminalProcessContext value);
static void terminal_process_finalize (GObject * obj);
static GType terminal_process_get_type_once (void);
static void _vala_terminal_process_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_terminal_process_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
VALA_EXTERN GType terminal_process_watcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalProcessWatcher, g_object_unref)
static TerminalProcessWatcher* terminal_process_watcher_new (void);
static TerminalProcessWatcher* terminal_process_watcher_construct (GType object_type);
VALA_EXTERN TerminalProcessWatcher* terminal_process_watcher_get_instance (void);
VALA_EXTERN gboolean terminal_process_watcher_watch (TerminalProcessWatcher* self,
                                         TerminalProcess* process);
static void terminal_process_watcher_start_watching (TerminalProcessWatcher* self);
static void terminal_process_watcher_t_watch_loop (TerminalProcessWatcher* self);
static gpointer _terminal_process_watcher_t_watch_loop_gthread_func (gpointer self);
static gboolean terminal_process_watcher_requires_process_watching (TerminalProcessWatcher* self);
static void terminal_process_watcher_check_process (TerminalProcessWatcher* self,
                                             TerminalProcess* process);
VALA_EXTERN GType terminal_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminalSettings, g_object_unref)
VALA_EXTERN TerminalSettings* terminal_settings_get_default (void);
VALA_EXTERN gboolean terminal_settings_get_context_aware_header_bar (TerminalSettings* self);
VALA_EXTERN gboolean terminal_settings_get_show_headerbar (TerminalSettings* self);
static gboolean terminal_process_watcher_is_process_still_running (TerminalProcessWatcher* self,
                                                            GPid pid);
VALA_EXTERN gboolean terminal_check_pid_running (gint pid);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN void terminal_get_foreground_process (gint terminal_fd,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
VALA_EXTERN gint terminal_get_foreground_process_finish (GAsyncResult* _res_);
static void ____lambda19_ (Block10Data* _data10_,
                    GObject* _,
                    GAsyncResult* res);
VALA_EXTERN gchar* terminal_get_process_cmdline (gint pid);
static void _____lambda19__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN gint terminal_get_euid_from_pid (gint pid,
                                 GCancellable* cancellable,
                                 GError** error);
static void terminal_process_watcher_finalize (GObject * obj);
static GType terminal_process_watcher_get_type_once (void);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
terminal_process_context_get_type_once (void)
{
	static const GEnumValue values[] = {{TERMINAL_PROCESS_CONTEXT_DEFAULT, "TERMINAL_PROCESS_CONTEXT_DEFAULT", "default"}, {TERMINAL_PROCESS_CONTEXT_ROOT, "TERMINAL_PROCESS_CONTEXT_ROOT", "root"}, {TERMINAL_PROCESS_CONTEXT_SSH, "TERMINAL_PROCESS_CONTEXT_SSH", "ssh"}, {0, NULL, NULL}};
	GType terminal_process_context_type_id;
	terminal_process_context_type_id = g_enum_register_static ("TerminalProcessContext", values);
	return terminal_process_context_type_id;
}

GType
terminal_process_context_get_type (void)
{
	static volatile gsize terminal_process_context_type_id__once = 0;
	if (g_once_init_enter (&terminal_process_context_type_id__once)) {
		GType terminal_process_context_type_id;
		terminal_process_context_type_id = terminal_process_context_get_type_once ();
		g_once_init_leave (&terminal_process_context_type_id__once, terminal_process_context_type_id);
	}
	return terminal_process_context_type_id__once;
}

static inline gpointer
terminal_process_get_instance_private (TerminalProcess* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalProcess_private_offset);
}

TerminalProcess*
terminal_process_construct (GType object_type)
{
	TerminalProcess * self = NULL;
#line 27 "../src/services/ProcessWatcher.vala"
	self = (TerminalProcess*) g_object_new (object_type, NULL);
#line 27 "../src/services/ProcessWatcher.vala"
	return self;
#line 282 "ProcessWatcher.c"
}

TerminalProcess*
terminal_process_new (void)
{
#line 27 "../src/services/ProcessWatcher.vala"
	return terminal_process_construct (TERMINAL_TYPE_PROCESS);
#line 290 "ProcessWatcher.c"
}

gint
terminal_process_get_terminal_fd (TerminalProcess* self)
{
	gint result;
#line 37 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/services/ProcessWatcher.vala"
	result = self->priv->_terminal_fd;
#line 37 "../src/services/ProcessWatcher.vala"
	return result;
#line 303 "ProcessWatcher.c"
}

void
terminal_process_set_terminal_fd (TerminalProcess* self,
                                  gint value)
{
	gint old_value;
#line 37 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/services/ProcessWatcher.vala"
	old_value = terminal_process_get_terminal_fd (self);
#line 37 "../src/services/ProcessWatcher.vala"
	if (old_value != value) {
#line 37 "../src/services/ProcessWatcher.vala"
		self->priv->_terminal_fd = value;
#line 37 "../src/services/ProcessWatcher.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_TERMINAL_FD_PROPERTY]);
#line 321 "ProcessWatcher.c"
	}
}

GPid
terminal_process_get_pid (TerminalProcess* self)
{
	GPid result;
#line 45 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "../src/services/ProcessWatcher.vala"
	result = self->priv->_pid;
#line 45 "../src/services/ProcessWatcher.vala"
	return result;
#line 335 "ProcessWatcher.c"
}

void
terminal_process_set_pid (TerminalProcess* self,
                          GPid value)
{
	GPid old_value;
#line 45 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/services/ProcessWatcher.vala"
	old_value = terminal_process_get_pid (self);
#line 45 "../src/services/ProcessWatcher.vala"
	if (old_value != value) {
#line 45 "../src/services/ProcessWatcher.vala"
		self->priv->_pid = value;
#line 45 "../src/services/ProcessWatcher.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_PID_PROPERTY]);
#line 353 "ProcessWatcher.c"
	}
}

GPid
terminal_process_get_foreground_pid (TerminalProcess* self)
{
	GPid result;
#line 53 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "../src/services/ProcessWatcher.vala"
	result = self->priv->_foreground_pid;
#line 53 "../src/services/ProcessWatcher.vala"
	return result;
#line 367 "ProcessWatcher.c"
}

void
terminal_process_set_foreground_pid (TerminalProcess* self,
                                     GPid value)
{
	GPid old_value;
#line 53 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/services/ProcessWatcher.vala"
	old_value = terminal_process_get_foreground_pid (self);
#line 53 "../src/services/ProcessWatcher.vala"
	if (old_value != value) {
#line 53 "../src/services/ProcessWatcher.vala"
		self->priv->_foreground_pid = value;
#line 53 "../src/services/ProcessWatcher.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY]);
#line 385 "ProcessWatcher.c"
	}
}

const gchar*
terminal_process_get_last_foreground_task_command (TerminalProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 55 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/services/ProcessWatcher.vala"
	_tmp0_ = self->priv->_last_foreground_task_command;
#line 55 "../src/services/ProcessWatcher.vala"
	result = _tmp0_;
#line 55 "../src/services/ProcessWatcher.vala"
	return result;
#line 402 "ProcessWatcher.c"
}

void
terminal_process_set_last_foreground_task_command (TerminalProcess* self,
                                                   const gchar* value)
{
	gchar* old_value;
#line 55 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/services/ProcessWatcher.vala"
	old_value = terminal_process_get_last_foreground_task_command (self);
#line 55 "../src/services/ProcessWatcher.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 416 "ProcessWatcher.c"
		gchar* _tmp0_;
#line 55 "../src/services/ProcessWatcher.vala"
		_tmp0_ = g_strdup (value);
#line 55 "../src/services/ProcessWatcher.vala"
		_g_free0 (self->priv->_last_foreground_task_command);
#line 55 "../src/services/ProcessWatcher.vala"
		self->priv->_last_foreground_task_command = _tmp0_;
#line 55 "../src/services/ProcessWatcher.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY]);
#line 426 "ProcessWatcher.c"
	}
}

gboolean
terminal_process_get_ended (TerminalProcess* self)
{
	gboolean result;
#line 62 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../src/services/ProcessWatcher.vala"
	result = self->priv->_ended;
#line 62 "../src/services/ProcessWatcher.vala"
	return result;
#line 440 "ProcessWatcher.c"
}

void
terminal_process_set_ended (TerminalProcess* self,
                            gboolean value)
{
	gboolean old_value;
#line 62 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/services/ProcessWatcher.vala"
	old_value = terminal_process_get_ended (self);
#line 62 "../src/services/ProcessWatcher.vala"
	if (old_value != value) {
#line 62 "../src/services/ProcessWatcher.vala"
		self->priv->_ended = value;
#line 62 "../src/services/ProcessWatcher.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_ENDED_PROPERTY]);
#line 458 "ProcessWatcher.c"
	}
}

TerminalProcessContext
terminal_process_get_context (TerminalProcess* self)
{
	TerminalProcessContext result;
#line 64 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 64 "../src/services/ProcessWatcher.vala"
	result = self->priv->_context;
#line 64 "../src/services/ProcessWatcher.vala"
	return result;
#line 472 "ProcessWatcher.c"
}

void
terminal_process_set_context (TerminalProcess* self,
                              TerminalProcessContext value)
{
	TerminalProcessContext old_value;
#line 64 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/services/ProcessWatcher.vala"
	old_value = terminal_process_get_context (self);
#line 64 "../src/services/ProcessWatcher.vala"
	if (old_value != value) {
#line 64 "../src/services/ProcessWatcher.vala"
		self->priv->_context = value;
#line 64 "../src/services/ProcessWatcher.vala"
		g_object_notify_by_pspec ((GObject *) self, terminal_process_properties[TERMINAL_PROCESS_CONTEXT_PROPERTY]);
#line 490 "ProcessWatcher.c"
	}
}

static void
terminal_process_class_init (TerminalProcessClass * klass,
                             gpointer klass_data)
{
#line 27 "../src/services/ProcessWatcher.vala"
	terminal_process_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/services/ProcessWatcher.vala"
	g_type_class_adjust_private_offset (klass, &TerminalProcess_private_offset);
#line 27 "../src/services/ProcessWatcher.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_process_get_property;
#line 27 "../src/services/ProcessWatcher.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_process_set_property;
#line 27 "../src/services/ProcessWatcher.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_process_finalize;
#line 508 "ProcessWatcher.c"
	/**
	   * This is the file descriptor used by the terminal we're tracking. This must
	   * be set during instanciation of this class and may not be modified later.
	   */
#line 27 "../src/services/ProcessWatcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_TERMINAL_FD_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_TERMINAL_FD_PROPERTY] = g_param_spec_int ("terminal-fd", "terminal-fd", "terminal-fd", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 515 "ProcessWatcher.c"
	/**
	   * This is the controlling PID for a terminal session. It will point to the
	   * user's shell, in most cases. If the terminal was created with a different
	   * command (i.e., `blackbox --command "sleep 300"`), this will point to the
	   * spawned process instead.
	   */
#line 27 "../src/services/ProcessWatcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_PID_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, (GPid) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 524 "ProcessWatcher.c"
	/**
	   * This is the PID of the process currently running at the top of the user's
	   * shell (e.g., if the user opened a terminal with bash, then opened Neovim
	   * with `nvim`, the foreground task for this session, and, consequently, this
	   * PID, will point to Neovim).
	   */
#line 27 "../src/services/ProcessWatcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY] = g_param_spec_int ("foreground-pid", "foreground-pid", "foreground-pid", G_MININT, G_MAXINT, (GPid) -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/services/ProcessWatcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY] = g_param_spec_string ("last-foreground-task-command", "last-foreground-task-command", "last-foreground-task-command", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 535 "ProcessWatcher.c"
	/***/
#line 27 "../src/services/ProcessWatcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_ENDED_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_ENDED_PROPERTY] = g_param_spec_boolean ("ended", "ended", "ended", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/services/ProcessWatcher.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_PROCESS_CONTEXT_PROPERTY, terminal_process_properties[TERMINAL_PROCESS_CONTEXT_PROPERTY] = g_param_spec_enum ("context", "context", "context", TERMINAL_TYPE_PROCESS_CONTEXT, TERMINAL_PROCESS_CONTEXT_DEFAULT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 541 "ProcessWatcher.c"
	/**
	   * This signal is emitted when the foreground task of a shell finishes.
	   */
#line 27 "../src/services/ProcessWatcher.vala"
	terminal_process_signals[TERMINAL_PROCESS_FOREGROUND_TASK_FINISHED_SIGNAL] = g_signal_new ("foreground-task-finished", TERMINAL_TYPE_PROCESS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 547 "ProcessWatcher.c"
}

static void
terminal_process_instance_init (TerminalProcess * self,
                                gpointer klass)
{
#line 27 "../src/services/ProcessWatcher.vala"
	self->priv = terminal_process_get_instance_private (self);
#line 45 "../src/services/ProcessWatcher.vala"
	self->priv->_pid = (GPid) -1;
#line 53 "../src/services/ProcessWatcher.vala"
	self->priv->_foreground_pid = (GPid) -1;
#line 55 "../src/services/ProcessWatcher.vala"
	self->priv->_last_foreground_task_command = NULL;
#line 62 "../src/services/ProcessWatcher.vala"
	self->priv->_ended = FALSE;
#line 64 "../src/services/ProcessWatcher.vala"
	self->priv->_context = TERMINAL_PROCESS_CONTEXT_DEFAULT;
#line 566 "ProcessWatcher.c"
}

static void
terminal_process_finalize (GObject * obj)
{
	TerminalProcess * self;
#line 27 "../src/services/ProcessWatcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_PROCESS, TerminalProcess);
#line 55 "../src/services/ProcessWatcher.vala"
	_g_free0 (self->priv->_last_foreground_task_command);
#line 27 "../src/services/ProcessWatcher.vala"
	G_OBJECT_CLASS (terminal_process_parent_class)->finalize (obj);
#line 579 "ProcessWatcher.c"
}

static GType
terminal_process_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalProcess), 0, (GInstanceInitFunc) terminal_process_instance_init, NULL };
	GType terminal_process_type_id;
	terminal_process_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminalProcess", &g_define_type_info, 0);
	TerminalProcess_private_offset = g_type_add_instance_private (terminal_process_type_id, sizeof (TerminalProcessPrivate));
	return terminal_process_type_id;
}

GType
terminal_process_get_type (void)
{
	static volatile gsize terminal_process_type_id__once = 0;
	if (g_once_init_enter (&terminal_process_type_id__once)) {
		GType terminal_process_type_id;
		terminal_process_type_id = terminal_process_get_type_once ();
		g_once_init_leave (&terminal_process_type_id__once, terminal_process_type_id);
	}
	return terminal_process_type_id__once;
}

static void
_vala_terminal_process_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	TerminalProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_PROCESS, TerminalProcess);
#line 27 "../src/services/ProcessWatcher.vala"
	switch (property_id) {
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_TERMINAL_FD_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		g_value_set_int (value, terminal_process_get_terminal_fd (self));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_PID_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		g_value_set_int (value, terminal_process_get_pid (self));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		g_value_set_int (value, terminal_process_get_foreground_pid (self));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		g_value_set_string (value, terminal_process_get_last_foreground_task_command (self));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_ENDED_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		g_value_set_boolean (value, terminal_process_get_ended (self));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_CONTEXT_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		g_value_set_enum (value, terminal_process_get_context (self));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 650 "ProcessWatcher.c"
		default:
#line 27 "../src/services/ProcessWatcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 656 "ProcessWatcher.c"
	}
}

static void
_vala_terminal_process_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	TerminalProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_TYPE_PROCESS, TerminalProcess);
#line 27 "../src/services/ProcessWatcher.vala"
	switch (property_id) {
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_TERMINAL_FD_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		terminal_process_set_terminal_fd (self, g_value_get_int (value));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_PID_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		terminal_process_set_pid (self, g_value_get_int (value));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_FOREGROUND_PID_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		terminal_process_set_foreground_pid (self, g_value_get_int (value));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_LAST_FOREGROUND_TASK_COMMAND_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		terminal_process_set_last_foreground_task_command (self, g_value_get_string (value));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_ENDED_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		terminal_process_set_ended (self, g_value_get_boolean (value));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 27 "../src/services/ProcessWatcher.vala"
		case TERMINAL_PROCESS_CONTEXT_PROPERTY:
#line 27 "../src/services/ProcessWatcher.vala"
		terminal_process_set_context (self, g_value_get_enum (value));
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 706 "ProcessWatcher.c"
		default:
#line 27 "../src/services/ProcessWatcher.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/services/ProcessWatcher.vala"
		break;
#line 712 "ProcessWatcher.c"
	}
}

static inline gpointer
terminal_process_watcher_get_instance_private (TerminalProcessWatcher* self)
{
	return G_STRUCT_MEMBER_P (self, TerminalProcessWatcher_private_offset);
}

static TerminalProcessWatcher*
terminal_process_watcher_construct (GType object_type)
{
	TerminalProcessWatcher * self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 80 "../src/services/ProcessWatcher.vala"
	self = (TerminalProcessWatcher*) g_object_new (object_type, NULL);
#line 81 "../src/services/ProcessWatcher.vala"
	_tmp0_ = gee_array_list_new (TERMINAL_TYPE_PROCESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 81 "../src/services/ProcessWatcher.vala"
	_g_object_unref0 (self->priv->process_list);
#line 81 "../src/services/ProcessWatcher.vala"
	self->priv->process_list = _tmp0_;
#line 82 "../src/services/ProcessWatcher.vala"
	_tmp1_ = gee_array_list_new (TERMINAL_TYPE_PROCESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 82 "../src/services/ProcessWatcher.vala"
	_g_object_unref0 (self->priv->pending_process_list);
#line 82 "../src/services/ProcessWatcher.vala"
	self->priv->pending_process_list = _tmp1_;
#line 80 "../src/services/ProcessWatcher.vala"
	return self;
#line 744 "ProcessWatcher.c"
}

static TerminalProcessWatcher*
terminal_process_watcher_new (void)
{
#line 80 "../src/services/ProcessWatcher.vala"
	return terminal_process_watcher_construct (TERMINAL_TYPE_PROCESS_WATCHER);
#line 752 "ProcessWatcher.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 89 "../src/services/ProcessWatcher.vala"
	return self ? g_object_ref (self) : NULL;
#line 760 "ProcessWatcher.c"
}

TerminalProcessWatcher*
terminal_process_watcher_get_instance (void)
{
	TerminalProcessWatcher* _tmp0_;
	TerminalProcessWatcher* _tmp2_;
	TerminalProcessWatcher* _tmp3_;
	TerminalProcessWatcher* result;
#line 86 "../src/services/ProcessWatcher.vala"
	_tmp0_ = terminal_process_watcher_instance;
#line 86 "../src/services/ProcessWatcher.vala"
	if (_tmp0_ == NULL) {
#line 774 "ProcessWatcher.c"
		TerminalProcessWatcher* _tmp1_;
#line 87 "../src/services/ProcessWatcher.vala"
		_tmp1_ = terminal_process_watcher_new ();
#line 87 "../src/services/ProcessWatcher.vala"
		_g_object_unref0 (terminal_process_watcher_instance);
#line 87 "../src/services/ProcessWatcher.vala"
		terminal_process_watcher_instance = _tmp1_;
#line 782 "ProcessWatcher.c"
	}
#line 89 "../src/services/ProcessWatcher.vala"
	_tmp2_ = terminal_process_watcher_instance;
#line 89 "../src/services/ProcessWatcher.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 89 "../src/services/ProcessWatcher.vala"
	result = _tmp3_;
#line 89 "../src/services/ProcessWatcher.vala"
	return result;
#line 792 "ProcessWatcher.c"
}

gboolean
terminal_process_watcher_watch (TerminalProcessWatcher* self,
                                TerminalProcess* process)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 92 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 92 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (process != NULL, FALSE);
#line 805 "ProcessWatcher.c"
	{
		GeeArrayList* _tmp0_;
#line 93 "../src/services/ProcessWatcher.vala"
		_tmp0_ = self->priv->pending_process_list;
#line 93 "../src/services/ProcessWatcher.vala"
		g_rec_mutex_lock (&self->priv->__lock_pending_process_list);
#line 812 "ProcessWatcher.c"
		{
			GeeArrayList* _tmp1_;
#line 94 "../src/services/ProcessWatcher.vala"
			_tmp1_ = self->priv->pending_process_list;
#line 94 "../src/services/ProcessWatcher.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, process);
#line 819 "ProcessWatcher.c"
		}
		__finally0:
		{
			GeeArrayList* _tmp2_;
#line 93 "../src/services/ProcessWatcher.vala"
			_tmp2_ = self->priv->pending_process_list;
#line 93 "../src/services/ProcessWatcher.vala"
			g_rec_mutex_unlock (&self->priv->__lock_pending_process_list);
#line 828 "ProcessWatcher.c"
		}
#line 93 "../src/services/ProcessWatcher.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 832 "ProcessWatcher.c"
			gboolean _tmp3_ = FALSE;
#line 93 "../src/services/ProcessWatcher.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 93 "../src/services/ProcessWatcher.vala"
			g_clear_error (&_inner_error0_);
#line 93 "../src/services/ProcessWatcher.vala"
			return _tmp3_;
#line 840 "ProcessWatcher.c"
		}
	}
#line 97 "../src/services/ProcessWatcher.vala"
	if (!self->priv->watching) {
#line 98 "../src/services/ProcessWatcher.vala"
		terminal_process_watcher_start_watching (self);
#line 847 "ProcessWatcher.c"
	}
#line 101 "../src/services/ProcessWatcher.vala"
	result = TRUE;
#line 101 "../src/services/ProcessWatcher.vala"
	return result;
#line 853 "ProcessWatcher.c"
}

static gpointer
_terminal_process_watcher_t_watch_loop_gthread_func (gpointer self)
{
	gpointer result;
#line 106 "../src/services/ProcessWatcher.vala"
	terminal_process_watcher_t_watch_loop ((TerminalProcessWatcher*) self);
#line 862 "ProcessWatcher.c"
	result = NULL;
#line 106 "../src/services/ProcessWatcher.vala"
	g_object_unref (self);
#line 106 "../src/services/ProcessWatcher.vala"
	return result;
#line 868 "ProcessWatcher.c"
}

static void
terminal_process_watcher_start_watching (TerminalProcessWatcher* self)
{
	GThread* _tmp0_;
#line 104 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/services/ProcessWatcher.vala"
	self->priv->watching = TRUE;
#line 106 "../src/services/ProcessWatcher.vala"
	_tmp0_ = g_thread_new ("process-watcher", _terminal_process_watcher_t_watch_loop_gthread_func, g_object_ref (self));
#line 106 "../src/services/ProcessWatcher.vala"
	_g_thread_unref0 (self->priv->loop_thread);
#line 106 "../src/services/ProcessWatcher.vala"
	self->priv->loop_thread = _tmp0_;
#line 885 "ProcessWatcher.c"
}

static void
terminal_process_watcher_t_watch_loop (TerminalProcessWatcher* self)
{
	GError* _inner_error0_ = NULL;
#line 121 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/services/ProcessWatcher.vala"
	while (TRUE) {
#line 896 "ProcessWatcher.c"
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gboolean ret = FALSE;
		GeeArrayList* _tmp53_;
		gint _tmp54_;
		gint _tmp55_;
#line 129 "../src/services/ProcessWatcher.vala"
		g_mutex_lock (&self->priv->mutex);
#line 906 "ProcessWatcher.c"
		{
			GeeArrayList* _tmp0_;
#line 131 "../src/services/ProcessWatcher.vala"
			_tmp0_ = self->priv->pending_process_list;
#line 131 "../src/services/ProcessWatcher.vala"
			g_rec_mutex_lock (&self->priv->__lock_pending_process_list);
#line 913 "ProcessWatcher.c"
			{
				GeeArrayList* _tmp1_;
				gint _tmp2_;
				gint _tmp3_;
#line 132 "../src/services/ProcessWatcher.vala"
				_tmp1_ = self->priv->pending_process_list;
#line 132 "../src/services/ProcessWatcher.vala"
				_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 132 "../src/services/ProcessWatcher.vala"
				_tmp3_ = _tmp2_;
#line 132 "../src/services/ProcessWatcher.vala"
				if (_tmp3_ > 0) {
#line 926 "ProcessWatcher.c"
					GeeArrayList* _tmp16_;
					{
						GeeArrayList* _process_list = NULL;
						GeeArrayList* _tmp4_;
						gint _process_size = 0;
						GeeArrayList* _tmp5_;
						gint _tmp6_;
						gint _tmp7_;
						gint _process_index = 0;
#line 133 "../src/services/ProcessWatcher.vala"
						_tmp4_ = self->priv->pending_process_list;
#line 133 "../src/services/ProcessWatcher.vala"
						_process_list = _tmp4_;
#line 133 "../src/services/ProcessWatcher.vala"
						_tmp5_ = _process_list;
#line 133 "../src/services/ProcessWatcher.vala"
						_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 133 "../src/services/ProcessWatcher.vala"
						_tmp7_ = _tmp6_;
#line 133 "../src/services/ProcessWatcher.vala"
						_process_size = _tmp7_;
#line 133 "../src/services/ProcessWatcher.vala"
						_process_index = -1;
#line 133 "../src/services/ProcessWatcher.vala"
						while (TRUE) {
#line 952 "ProcessWatcher.c"
							gint _tmp8_;
							gint _tmp9_;
							TerminalProcess* process = NULL;
							GeeArrayList* _tmp10_;
							gpointer _tmp11_;
							GeeArrayList* _tmp12_;
							TerminalProcess* _tmp13_;
#line 133 "../src/services/ProcessWatcher.vala"
							_process_index = _process_index + 1;
#line 133 "../src/services/ProcessWatcher.vala"
							_tmp8_ = _process_index;
#line 133 "../src/services/ProcessWatcher.vala"
							_tmp9_ = _process_size;
#line 133 "../src/services/ProcessWatcher.vala"
							if (!(_tmp8_ < _tmp9_)) {
#line 133 "../src/services/ProcessWatcher.vala"
								break;
#line 970 "ProcessWatcher.c"
							}
#line 133 "../src/services/ProcessWatcher.vala"
							_tmp10_ = _process_list;
#line 133 "../src/services/ProcessWatcher.vala"
							_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _process_index);
#line 133 "../src/services/ProcessWatcher.vala"
							process = (TerminalProcess*) _tmp11_;
#line 134 "../src/services/ProcessWatcher.vala"
							_tmp12_ = self->priv->process_list;
#line 134 "../src/services/ProcessWatcher.vala"
							_tmp13_ = process;
#line 134 "../src/services/ProcessWatcher.vala"
							if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp12_, _tmp13_)) {
#line 984 "ProcessWatcher.c"
								GeeArrayList* _tmp14_;
								TerminalProcess* _tmp15_;
#line 135 "../src/services/ProcessWatcher.vala"
								_tmp14_ = self->priv->process_list;
#line 135 "../src/services/ProcessWatcher.vala"
								_tmp15_ = process;
#line 135 "../src/services/ProcessWatcher.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 993 "ProcessWatcher.c"
							}
#line 133 "../src/services/ProcessWatcher.vala"
							_g_object_unref0 (process);
#line 997 "ProcessWatcher.c"
						}
					}
#line 138 "../src/services/ProcessWatcher.vala"
					_tmp16_ = self->priv->pending_process_list;
#line 138 "../src/services/ProcessWatcher.vala"
					gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp16_);
#line 1004 "ProcessWatcher.c"
				}
			}
			__finally0:
			{
				GeeArrayList* _tmp17_;
#line 131 "../src/services/ProcessWatcher.vala"
				_tmp17_ = self->priv->pending_process_list;
#line 131 "../src/services/ProcessWatcher.vala"
				g_rec_mutex_unlock (&self->priv->__lock_pending_process_list);
#line 1014 "ProcessWatcher.c"
			}
#line 131 "../src/services/ProcessWatcher.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/services/ProcessWatcher.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 131 "../src/services/ProcessWatcher.vala"
				g_clear_error (&_inner_error0_);
#line 131 "../src/services/ProcessWatcher.vala"
				return;
#line 1024 "ProcessWatcher.c"
			}
		}
#line 142 "../src/services/ProcessWatcher.vala"
		_tmp18_ = self->priv->process_list;
#line 142 "../src/services/ProcessWatcher.vala"
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 142 "../src/services/ProcessWatcher.vala"
		_tmp20_ = _tmp19_;
#line 142 "../src/services/ProcessWatcher.vala"
		g_debug ("ProcessWatcher.vala:142: Watching %d processes", _tmp20_);
#line 144 "../src/services/ProcessWatcher.vala"
		if (terminal_process_watcher_requires_process_watching (self)) {
#line 1037 "ProcessWatcher.c"
			{
				GeeArrayList* _process_list = NULL;
				GeeArrayList* _tmp21_;
				gint _process_size = 0;
				GeeArrayList* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _process_index = 0;
#line 145 "../src/services/ProcessWatcher.vala"
				_tmp21_ = self->priv->process_list;
#line 145 "../src/services/ProcessWatcher.vala"
				_process_list = _tmp21_;
#line 145 "../src/services/ProcessWatcher.vala"
				_tmp22_ = _process_list;
#line 145 "../src/services/ProcessWatcher.vala"
				_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 145 "../src/services/ProcessWatcher.vala"
				_tmp24_ = _tmp23_;
#line 145 "../src/services/ProcessWatcher.vala"
				_process_size = _tmp24_;
#line 145 "../src/services/ProcessWatcher.vala"
				_process_index = -1;
#line 145 "../src/services/ProcessWatcher.vala"
				while (TRUE) {
#line 1062 "ProcessWatcher.c"
					gint _tmp25_;
					gint _tmp26_;
					TerminalProcess* process = NULL;
					GeeArrayList* _tmp27_;
					gpointer _tmp28_;
					TerminalProcess* _tmp29_;
#line 145 "../src/services/ProcessWatcher.vala"
					_process_index = _process_index + 1;
#line 145 "../src/services/ProcessWatcher.vala"
					_tmp25_ = _process_index;
#line 145 "../src/services/ProcessWatcher.vala"
					_tmp26_ = _process_size;
#line 145 "../src/services/ProcessWatcher.vala"
					if (!(_tmp25_ < _tmp26_)) {
#line 145 "../src/services/ProcessWatcher.vala"
						break;
#line 1079 "ProcessWatcher.c"
					}
#line 145 "../src/services/ProcessWatcher.vala"
					_tmp27_ = _process_list;
#line 145 "../src/services/ProcessWatcher.vala"
					_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _process_index);
#line 145 "../src/services/ProcessWatcher.vala"
					process = (TerminalProcess*) _tmp28_;
#line 146 "../src/services/ProcessWatcher.vala"
					_tmp29_ = process;
#line 146 "../src/services/ProcessWatcher.vala"
					terminal_process_watcher_check_process (self, _tmp29_);
#line 145 "../src/services/ProcessWatcher.vala"
					_g_object_unref0 (process);
#line 1093 "ProcessWatcher.c"
				}
			}
		} else {
			{
				GeeArrayList* _process_list = NULL;
				GeeArrayList* _tmp30_;
				gint _process_size = 0;
				GeeArrayList* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _process_index = 0;
#line 150 "../src/services/ProcessWatcher.vala"
				_tmp30_ = self->priv->process_list;
#line 150 "../src/services/ProcessWatcher.vala"
				_process_list = _tmp30_;
#line 150 "../src/services/ProcessWatcher.vala"
				_tmp31_ = _process_list;
#line 150 "../src/services/ProcessWatcher.vala"
				_tmp32_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp31_);
#line 150 "../src/services/ProcessWatcher.vala"
				_tmp33_ = _tmp32_;
#line 150 "../src/services/ProcessWatcher.vala"
				_process_size = _tmp33_;
#line 150 "../src/services/ProcessWatcher.vala"
				_process_index = -1;
#line 150 "../src/services/ProcessWatcher.vala"
				while (TRUE) {
#line 1121 "ProcessWatcher.c"
					gint _tmp34_;
					gint _tmp35_;
					TerminalProcess* process = NULL;
					GeeArrayList* _tmp36_;
					gpointer _tmp37_;
					TerminalProcess* _tmp38_;
#line 150 "../src/services/ProcessWatcher.vala"
					_process_index = _process_index + 1;
#line 150 "../src/services/ProcessWatcher.vala"
					_tmp34_ = _process_index;
#line 150 "../src/services/ProcessWatcher.vala"
					_tmp35_ = _process_size;
#line 150 "../src/services/ProcessWatcher.vala"
					if (!(_tmp34_ < _tmp35_)) {
#line 150 "../src/services/ProcessWatcher.vala"
						break;
#line 1138 "ProcessWatcher.c"
					}
#line 150 "../src/services/ProcessWatcher.vala"
					_tmp36_ = _process_list;
#line 150 "../src/services/ProcessWatcher.vala"
					_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _process_index);
#line 150 "../src/services/ProcessWatcher.vala"
					process = (TerminalProcess*) _tmp37_;
#line 151 "../src/services/ProcessWatcher.vala"
					_tmp38_ = process;
#line 151 "../src/services/ProcessWatcher.vala"
					terminal_process_set_context (_tmp38_, TERMINAL_PROCESS_CONTEXT_DEFAULT);
#line 150 "../src/services/ProcessWatcher.vala"
					_g_object_unref0 (process);
#line 1152 "ProcessWatcher.c"
				}
			}
		}
		{
			gint i = 0;
#line 155 "../src/services/ProcessWatcher.vala"
			i = 0;
#line 1160 "ProcessWatcher.c"
			{
				gboolean _tmp39_ = FALSE;
#line 155 "../src/services/ProcessWatcher.vala"
				_tmp39_ = TRUE;
#line 155 "../src/services/ProcessWatcher.vala"
				while (TRUE) {
#line 1167 "ProcessWatcher.c"
					GeeArrayList* _tmp40_;
					gint _tmp41_;
					gint _tmp42_;
					GeeArrayList* _tmp43_;
					gpointer _tmp44_;
					TerminalProcess* _tmp45_;
					gboolean _tmp46_;
					gboolean _tmp47_;
					gboolean _tmp48_;
#line 155 "../src/services/ProcessWatcher.vala"
					if (!_tmp39_) {
#line 1179 "ProcessWatcher.c"
					}
#line 155 "../src/services/ProcessWatcher.vala"
					_tmp39_ = FALSE;
#line 155 "../src/services/ProcessWatcher.vala"
					_tmp40_ = self->priv->process_list;
#line 155 "../src/services/ProcessWatcher.vala"
					_tmp41_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp40_);
#line 155 "../src/services/ProcessWatcher.vala"
					_tmp42_ = _tmp41_;
#line 155 "../src/services/ProcessWatcher.vala"
					if (!(i < _tmp42_)) {
#line 155 "../src/services/ProcessWatcher.vala"
						break;
#line 1193 "ProcessWatcher.c"
					}
#line 156 "../src/services/ProcessWatcher.vala"
					_tmp43_ = self->priv->process_list;
#line 156 "../src/services/ProcessWatcher.vala"
					_tmp44_ = gee_abstract_list_get ((GeeAbstractList*) _tmp43_, i);
#line 156 "../src/services/ProcessWatcher.vala"
					_tmp45_ = (TerminalProcess*) _tmp44_;
#line 156 "../src/services/ProcessWatcher.vala"
					_tmp46_ = terminal_process_get_ended (_tmp45_);
#line 156 "../src/services/ProcessWatcher.vala"
					_tmp47_ = _tmp46_;
#line 156 "../src/services/ProcessWatcher.vala"
					_tmp48_ = _tmp47_;
#line 156 "../src/services/ProcessWatcher.vala"
					_g_object_unref0 (_tmp45_);
#line 156 "../src/services/ProcessWatcher.vala"
					if (_tmp48_) {
#line 1211 "ProcessWatcher.c"
						GeeArrayList* _tmp49_;
						gpointer _tmp50_;
						TerminalProcess* _tmp51_;
#line 157 "../src/services/ProcessWatcher.vala"
						_tmp49_ = self->priv->process_list;
#line 157 "../src/services/ProcessWatcher.vala"
						_tmp50_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp49_, i);
#line 157 "../src/services/ProcessWatcher.vala"
						_tmp51_ = (TerminalProcess*) _tmp50_;
#line 157 "../src/services/ProcessWatcher.vala"
						_g_object_unref0 (_tmp51_);
#line 1223 "ProcessWatcher.c"
					} else {
						gint _tmp52_;
#line 160 "../src/services/ProcessWatcher.vala"
						_tmp52_ = i;
#line 160 "../src/services/ProcessWatcher.vala"
						i = _tmp52_ + 1;
#line 1230 "ProcessWatcher.c"
					}
				}
			}
		}
#line 164 "../src/services/ProcessWatcher.vala"
		_tmp53_ = self->priv->process_list;
#line 164 "../src/services/ProcessWatcher.vala"
		_tmp54_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp53_);
#line 164 "../src/services/ProcessWatcher.vala"
		_tmp55_ = _tmp54_;
#line 164 "../src/services/ProcessWatcher.vala"
		ret = _tmp55_ > 0;
#line 165 "../src/services/ProcessWatcher.vala"
		self->priv->watching = ret;
#line 166 "../src/services/ProcessWatcher.vala"
		g_mutex_unlock (&self->priv->mutex);
#line 168 "../src/services/ProcessWatcher.vala"
		if (!ret) {
#line 169 "../src/services/ProcessWatcher.vala"
			break;
#line 1251 "ProcessWatcher.c"
		}
#line 172 "../src/services/ProcessWatcher.vala"
		g_usleep ((gulong) (1000 * TERMINAL_PROCESS_WATCHER_INTERVAL_MS));
#line 1255 "ProcessWatcher.c"
	}
}

static gboolean
terminal_process_watcher_requires_process_watching (TerminalProcessWatcher* self)
{
	gboolean _tmp0_ = FALSE;
	TerminalSettings* _tmp1_;
	TerminalSettings* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 176 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 177 "../src/services/ProcessWatcher.vala"
	_tmp1_ = terminal_settings_get_default ();
#line 177 "../src/services/ProcessWatcher.vala"
	_tmp2_ = _tmp1_;
#line 177 "../src/services/ProcessWatcher.vala"
	_tmp3_ = terminal_settings_get_context_aware_header_bar (_tmp2_);
#line 177 "../src/services/ProcessWatcher.vala"
	_tmp4_ = _tmp3_;
#line 177 "../src/services/ProcessWatcher.vala"
	_tmp5_ = _tmp4_;
#line 177 "../src/services/ProcessWatcher.vala"
	_g_object_unref0 (_tmp2_);
#line 177 "../src/services/ProcessWatcher.vala"
	if (_tmp5_) {
#line 1285 "ProcessWatcher.c"
		TerminalSettings* _tmp6_;
		TerminalSettings* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 178 "../src/services/ProcessWatcher.vala"
		_tmp6_ = terminal_settings_get_default ();
#line 178 "../src/services/ProcessWatcher.vala"
		_tmp7_ = _tmp6_;
#line 178 "../src/services/ProcessWatcher.vala"
		_tmp8_ = terminal_settings_get_show_headerbar (_tmp7_);
#line 178 "../src/services/ProcessWatcher.vala"
		_tmp9_ = _tmp8_;
#line 178 "../src/services/ProcessWatcher.vala"
		_tmp0_ = _tmp9_;
#line 178 "../src/services/ProcessWatcher.vala"
		_g_object_unref0 (_tmp7_);
#line 1302 "ProcessWatcher.c"
	} else {
#line 177 "../src/services/ProcessWatcher.vala"
		_tmp0_ = FALSE;
#line 1306 "ProcessWatcher.c"
	}
#line 177 "../src/services/ProcessWatcher.vala"
	result = _tmp0_;
#line 177 "../src/services/ProcessWatcher.vala"
	return result;
#line 1312 "ProcessWatcher.c"
}

static gboolean
terminal_process_watcher_is_process_still_running (TerminalProcessWatcher* self,
                                                   GPid pid)
{
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 181 "../src/services/ProcessWatcher.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1324 "ProcessWatcher.c"
	{
#line 183 "../src/services/ProcessWatcher.vala"
		result = terminal_check_pid_running ((gint) pid);
#line 183 "../src/services/ProcessWatcher.vala"
		return result;
#line 1330 "ProcessWatcher.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 182 "../src/services/ProcessWatcher.vala"
		e = _inner_error0_;
#line 182 "../src/services/ProcessWatcher.vala"
		_inner_error0_ = NULL;
#line 186 "../src/services/ProcessWatcher.vala"
		_tmp0_ = e;
#line 186 "../src/services/ProcessWatcher.vala"
		_tmp1_ = _tmp0_->message;
#line 186 "../src/services/ProcessWatcher.vala"
		g_warning ("ProcessWatcher.vala:186: %s", _tmp1_);
#line 182 "../src/services/ProcessWatcher.vala"
		_g_error_free0 (e);
#line 1350 "ProcessWatcher.c"
	}
	__finally0:
#line 182 "../src/services/ProcessWatcher.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../src/services/ProcessWatcher.vala"
	g_clear_error (&_inner_error0_);
#line 182 "../src/services/ProcessWatcher.vala"
	return _tmp2_;
#line 188 "../src/services/ProcessWatcher.vala"
	result = FALSE;
#line 188 "../src/services/ProcessWatcher.vala"
	return result;
#line 1363 "ProcessWatcher.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 191 "../src/services/ProcessWatcher.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 191 "../src/services/ProcessWatcher.vala"
	return _data10_;
#line 1373 "ProcessWatcher.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 191 "../src/services/ProcessWatcher.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1383 "ProcessWatcher.c"
		TerminalProcessWatcher* self;
#line 191 "../src/services/ProcessWatcher.vala"
		self = _data10_->self;
#line 191 "../src/services/ProcessWatcher.vala"
		_g_object_unref0 (_data10_->process);
#line 191 "../src/services/ProcessWatcher.vala"
		_g_object_unref0 (self);
#line 191 "../src/services/ProcessWatcher.vala"
		g_slice_free (Block10Data, _data10_);
#line 1393 "ProcessWatcher.c"
	}
}

static void
____lambda19_ (Block10Data* _data10_,
               GObject* _,
               GAsyncResult* res)
{
	TerminalProcessWatcher* self;
	gint foreground_pid = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 207 "../src/services/ProcessWatcher.vala"
	self = _data10_->self;
#line 207 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (res != NULL);
#line 208 "../src/services/ProcessWatcher.vala"
	foreground_pid = terminal_get_foreground_process_finish (res);
#line 211 "../src/services/ProcessWatcher.vala"
	if (foreground_pid >= 0) {
#line 1414 "ProcessWatcher.c"
		GPid _tmp2_;
		GPid _tmp3_;
#line 212 "../src/services/ProcessWatcher.vala"
		_tmp2_ = terminal_process_get_pid (_data10_->process);
#line 212 "../src/services/ProcessWatcher.vala"
		_tmp3_ = _tmp2_;
#line 212 "../src/services/ProcessWatcher.vala"
		_tmp1_ = foreground_pid != ((gint) _tmp3_);
#line 1423 "ProcessWatcher.c"
	} else {
#line 211 "../src/services/ProcessWatcher.vala"
		_tmp1_ = FALSE;
#line 1427 "ProcessWatcher.c"
	}
#line 211 "../src/services/ProcessWatcher.vala"
	if (_tmp1_) {
#line 1431 "ProcessWatcher.c"
		GPid _tmp4_;
		GPid _tmp5_;
#line 213 "../src/services/ProcessWatcher.vala"
		_tmp4_ = terminal_process_get_foreground_pid (_data10_->process);
#line 213 "../src/services/ProcessWatcher.vala"
		_tmp5_ = _tmp4_;
#line 213 "../src/services/ProcessWatcher.vala"
		_tmp0_ = foreground_pid != ((gint) _tmp5_);
#line 1440 "ProcessWatcher.c"
	} else {
#line 211 "../src/services/ProcessWatcher.vala"
		_tmp0_ = FALSE;
#line 1444 "ProcessWatcher.c"
	}
#line 210 "../src/services/ProcessWatcher.vala"
	if (_tmp0_) {
#line 1448 "ProcessWatcher.c"
		gchar* cmdline = NULL;
		gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		const gchar* _tmp8_;
		const gchar* _tmp10_;
#line 215 "../src/services/ProcessWatcher.vala"
		_tmp6_ = terminal_get_process_cmdline (foreground_pid);
#line 215 "../src/services/ProcessWatcher.vala"
		cmdline = _tmp6_;
#line 217 "../src/services/ProcessWatcher.vala"
		_tmp8_ = cmdline;
#line 217 "../src/services/ProcessWatcher.vala"
		if (_tmp8_ == NULL) {
#line 217 "../src/services/ProcessWatcher.vala"
			_tmp7_ = TRUE;
#line 1464 "ProcessWatcher.c"
		} else {
			const gchar* _tmp9_;
#line 217 "../src/services/ProcessWatcher.vala"
			_tmp9_ = cmdline;
#line 217 "../src/services/ProcessWatcher.vala"
			_tmp7_ = g_strcmp0 (_tmp9_, "") == 0;
#line 1471 "ProcessWatcher.c"
		}
#line 217 "../src/services/ProcessWatcher.vala"
		if (_tmp7_) {
#line 219 "../src/services/ProcessWatcher.vala"
			g_debug ("ProcessWatcher.vala:219: Skipping process with empty cmdline");
#line 220 "../src/services/ProcessWatcher.vala"
			_g_free0 (cmdline);
#line 220 "../src/services/ProcessWatcher.vala"
			return;
#line 1481 "ProcessWatcher.c"
		}
#line 223 "../src/services/ProcessWatcher.vala"
		terminal_process_set_foreground_pid (_data10_->process, (GPid) foreground_pid);
#line 224 "../src/services/ProcessWatcher.vala"
		_tmp10_ = cmdline;
#line 224 "../src/services/ProcessWatcher.vala"
		terminal_process_set_last_foreground_task_command (_data10_->process, _tmp10_);
#line 210 "../src/services/ProcessWatcher.vala"
		_g_free0 (cmdline);
#line 1491 "ProcessWatcher.c"
	}
}

static void
_____lambda19__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 207 "../src/services/ProcessWatcher.vala"
	____lambda19_ (self, source_object, res);
#line 207 "../src/services/ProcessWatcher.vala"
	block10_data_unref (self);
#line 1504 "ProcessWatcher.c"
}

static void
terminal_process_watcher_check_process (TerminalProcessWatcher* self,
                                        TerminalProcess* process)
{
	Block10Data* _data10_;
	TerminalProcess* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 191 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/services/ProcessWatcher.vala"
	g_return_if_fail (process != NULL);
#line 191 "../src/services/ProcessWatcher.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 191 "../src/services/ProcessWatcher.vala"
	_data10_->_ref_count_ = 1;
#line 191 "../src/services/ProcessWatcher.vala"
	_data10_->self = g_object_ref (self);
#line 191 "../src/services/ProcessWatcher.vala"
	_tmp0_ = _g_object_ref0 (process);
#line 191 "../src/services/ProcessWatcher.vala"
	_g_object_unref0 (_data10_->process);
#line 191 "../src/services/ProcessWatcher.vala"
	_data10_->process = _tmp0_;
#line 1530 "ProcessWatcher.c"
	{
		{
			gboolean _tmp1_ = FALSE;
			GPid _tmp2_;
			GPid _tmp3_;
#line 198 "../src/services/ProcessWatcher.vala"
			_tmp2_ = terminal_process_get_foreground_pid (_data10_->process);
#line 198 "../src/services/ProcessWatcher.vala"
			_tmp3_ = _tmp2_;
#line 198 "../src/services/ProcessWatcher.vala"
			if (_tmp3_ >= ((GPid) 0)) {
#line 1542 "ProcessWatcher.c"
				GPid _tmp4_;
				GPid _tmp5_;
#line 199 "../src/services/ProcessWatcher.vala"
				_tmp4_ = terminal_process_get_foreground_pid (_data10_->process);
#line 199 "../src/services/ProcessWatcher.vala"
				_tmp5_ = _tmp4_;
#line 199 "../src/services/ProcessWatcher.vala"
				_tmp1_ = !terminal_process_watcher_is_process_still_running (self, _tmp5_);
#line 1551 "ProcessWatcher.c"
			} else {
#line 198 "../src/services/ProcessWatcher.vala"
				_tmp1_ = FALSE;
#line 1555 "ProcessWatcher.c"
			}
#line 197 "../src/services/ProcessWatcher.vala"
			if (_tmp1_) {
#line 201 "../src/services/ProcessWatcher.vala"
				g_signal_emit (_data10_->process, terminal_process_signals[TERMINAL_PROCESS_FOREGROUND_TASK_FINISHED_SIGNAL], 0);
#line 202 "../src/services/ProcessWatcher.vala"
				terminal_process_set_foreground_pid (_data10_->process, (GPid) -1);
#line 1563 "ProcessWatcher.c"
			}
		}
		{
			gint _tmp6_;
			gint _tmp7_;
#line 207 "../src/services/ProcessWatcher.vala"
			_tmp6_ = terminal_process_get_terminal_fd (_data10_->process);
#line 207 "../src/services/ProcessWatcher.vala"
			_tmp7_ = _tmp6_;
#line 207 "../src/services/ProcessWatcher.vala"
			terminal_get_foreground_process (_tmp7_, NULL, _____lambda19__gasync_ready_callback, block10_data_ref (_data10_));
#line 1575 "ProcessWatcher.c"
		}
		{
			GPid _tmp8_;
			GPid _tmp9_;
#line 231 "../src/services/ProcessWatcher.vala"
			_tmp8_ = terminal_process_get_pid (_data10_->process);
#line 231 "../src/services/ProcessWatcher.vala"
			_tmp9_ = _tmp8_;
#line 231 "../src/services/ProcessWatcher.vala"
			terminal_process_set_ended (_data10_->process, !terminal_check_pid_running ((gint) _tmp9_));
#line 1586 "ProcessWatcher.c"
		}
		{
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 236 "../src/services/ProcessWatcher.vala"
			_tmp10_ = terminal_process_get_ended (_data10_->process);
#line 236 "../src/services/ProcessWatcher.vala"
			_tmp11_ = _tmp10_;
#line 236 "../src/services/ProcessWatcher.vala"
			if (!_tmp11_) {
#line 1597 "ProcessWatcher.c"
				{
					GPid _tmp12_ = 0;
					GPid _tmp13_;
					GPid _tmp14_;
					GPid source_pid = 0;
					gint euid = 0;
#line 238 "../src/services/ProcessWatcher.vala"
					_tmp13_ = terminal_process_get_foreground_pid (_data10_->process);
#line 238 "../src/services/ProcessWatcher.vala"
					_tmp14_ = _tmp13_;
#line 238 "../src/services/ProcessWatcher.vala"
					if (_tmp14_ > ((GPid) -1)) {
#line 1610 "ProcessWatcher.c"
						GPid _tmp15_;
						GPid _tmp16_;
#line 239 "../src/services/ProcessWatcher.vala"
						_tmp15_ = terminal_process_get_foreground_pid (_data10_->process);
#line 239 "../src/services/ProcessWatcher.vala"
						_tmp16_ = _tmp15_;
#line 239 "../src/services/ProcessWatcher.vala"
						_tmp12_ = _tmp16_;
#line 1619 "ProcessWatcher.c"
					} else {
						GPid _tmp17_;
						GPid _tmp18_;
#line 240 "../src/services/ProcessWatcher.vala"
						_tmp17_ = terminal_process_get_pid (_data10_->process);
#line 240 "../src/services/ProcessWatcher.vala"
						_tmp18_ = _tmp17_;
#line 240 "../src/services/ProcessWatcher.vala"
						_tmp12_ = _tmp18_;
#line 1629 "ProcessWatcher.c"
					}
#line 238 "../src/services/ProcessWatcher.vala"
					source_pid = _tmp12_;
#line 242 "../src/services/ProcessWatcher.vala"
					euid = terminal_get_euid_from_pid ((gint) source_pid, NULL, &_inner_error0_);
#line 242 "../src/services/ProcessWatcher.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1637 "ProcessWatcher.c"
						goto __catch1_g_error;
					}
#line 244 "../src/services/ProcessWatcher.vala"
					if (euid == 0) {
#line 245 "../src/services/ProcessWatcher.vala"
						terminal_process_set_context (_data10_->process, TERMINAL_PROCESS_CONTEXT_ROOT);
#line 1644 "ProcessWatcher.c"
					} else {
						gchar* command = NULL;
						gchar* _tmp19_;
						gboolean _tmp20_ = FALSE;
						const gchar* _tmp21_;
#line 248 "../src/services/ProcessWatcher.vala"
						_tmp19_ = terminal_get_process_cmdline ((gint) source_pid);
#line 248 "../src/services/ProcessWatcher.vala"
						command = _tmp19_;
#line 250 "../src/services/ProcessWatcher.vala"
						_tmp21_ = command;
#line 250 "../src/services/ProcessWatcher.vala"
						if (_tmp21_ != NULL) {
#line 1658 "ProcessWatcher.c"
							const gchar* _tmp22_;
#line 250 "../src/services/ProcessWatcher.vala"
							_tmp22_ = command;
#line 250 "../src/services/ProcessWatcher.vala"
							_tmp20_ = g_str_has_prefix (_tmp22_, "ssh");
#line 1664 "ProcessWatcher.c"
						} else {
#line 250 "../src/services/ProcessWatcher.vala"
							_tmp20_ = FALSE;
#line 1668 "ProcessWatcher.c"
						}
#line 250 "../src/services/ProcessWatcher.vala"
						if (_tmp20_) {
#line 251 "../src/services/ProcessWatcher.vala"
							terminal_process_set_context (_data10_->process, TERMINAL_PROCESS_CONTEXT_SSH);
#line 1674 "ProcessWatcher.c"
						} else {
#line 254 "../src/services/ProcessWatcher.vala"
							terminal_process_set_context (_data10_->process, TERMINAL_PROCESS_CONTEXT_DEFAULT);
#line 1678 "ProcessWatcher.c"
						}
#line 244 "../src/services/ProcessWatcher.vala"
						_g_free0 (command);
#line 1682 "ProcessWatcher.c"
					}
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GError* _tmp23_;
					const gchar* _tmp24_;
#line 237 "../src/services/ProcessWatcher.vala"
					e = _inner_error0_;
#line 237 "../src/services/ProcessWatcher.vala"
					_inner_error0_ = NULL;
#line 259 "../src/services/ProcessWatcher.vala"
					_tmp23_ = e;
#line 259 "../src/services/ProcessWatcher.vala"
					_tmp24_ = _tmp23_->message;
#line 259 "../src/services/ProcessWatcher.vala"
					g_warning ("ProcessWatcher.vala:259: %s", _tmp24_);
#line 237 "../src/services/ProcessWatcher.vala"
					_g_error_free0 (e);
#line 1703 "ProcessWatcher.c"
				}
				__finally1:
#line 237 "../src/services/ProcessWatcher.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1708 "ProcessWatcher.c"
					goto __catch0_g_error;
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp25_;
		const gchar* _tmp26_;
#line 192 "../src/services/ProcessWatcher.vala"
		e = _inner_error0_;
#line 192 "../src/services/ProcessWatcher.vala"
		_inner_error0_ = NULL;
#line 265 "../src/services/ProcessWatcher.vala"
		_tmp25_ = e;
#line 265 "../src/services/ProcessWatcher.vala"
		_tmp26_ = _tmp25_->message;
#line 265 "../src/services/ProcessWatcher.vala"
		g_warning ("ProcessWatcher.vala:265: %s", _tmp26_);
#line 192 "../src/services/ProcessWatcher.vala"
		_g_error_free0 (e);
#line 1732 "ProcessWatcher.c"
	}
	__finally0:
#line 192 "../src/services/ProcessWatcher.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "../src/services/ProcessWatcher.vala"
		block10_data_unref (_data10_);
#line 192 "../src/services/ProcessWatcher.vala"
		_data10_ = NULL;
#line 192 "../src/services/ProcessWatcher.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "../src/services/ProcessWatcher.vala"
		g_clear_error (&_inner_error0_);
#line 192 "../src/services/ProcessWatcher.vala"
		return;
#line 1747 "ProcessWatcher.c"
	}
#line 191 "../src/services/ProcessWatcher.vala"
	block10_data_unref (_data10_);
#line 191 "../src/services/ProcessWatcher.vala"
	_data10_ = NULL;
#line 1753 "ProcessWatcher.c"
}

static void
terminal_process_watcher_class_init (TerminalProcessWatcherClass * klass,
                                     gpointer klass_data)
{
#line 71 "../src/services/ProcessWatcher.vala"
	terminal_process_watcher_parent_class = g_type_class_peek_parent (klass);
#line 71 "../src/services/ProcessWatcher.vala"
	g_type_class_adjust_private_offset (klass, &TerminalProcessWatcher_private_offset);
#line 71 "../src/services/ProcessWatcher.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_process_watcher_finalize;
#line 1766 "ProcessWatcher.c"
}

static void
terminal_process_watcher_instance_init (TerminalProcessWatcher * self,
                                        gpointer klass)
{
#line 71 "../src/services/ProcessWatcher.vala"
	self->priv = terminal_process_watcher_get_instance_private (self);
#line 75 "../src/services/ProcessWatcher.vala"
	g_rec_mutex_init (&self->priv->__lock_pending_process_list);
#line 76 "../src/services/ProcessWatcher.vala"
	self->priv->watching = FALSE;
#line 77 "../src/services/ProcessWatcher.vala"
	self->priv->loop_thread = NULL;
#line 78 "../src/services/ProcessWatcher.vala"
	g_mutex_init (&self->priv->mutex);
#line 1783 "ProcessWatcher.c"
}

static void
terminal_process_watcher_finalize (GObject * obj)
{
	TerminalProcessWatcher * self;
#line 71 "../src/services/ProcessWatcher.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_TYPE_PROCESS_WATCHER, TerminalProcessWatcher);
#line 74 "../src/services/ProcessWatcher.vala"
	_g_object_unref0 (self->priv->process_list);
#line 75 "../src/services/ProcessWatcher.vala"
	g_rec_mutex_clear (&self->priv->__lock_pending_process_list);
#line 75 "../src/services/ProcessWatcher.vala"
	_g_object_unref0 (self->priv->pending_process_list);
#line 77 "../src/services/ProcessWatcher.vala"
	_g_thread_unref0 (self->priv->loop_thread);
#line 78 "../src/services/ProcessWatcher.vala"
	_vala_clear_GMutex (&self->priv->mutex);
#line 71 "../src/services/ProcessWatcher.vala"
	G_OBJECT_CLASS (terminal_process_watcher_parent_class)->finalize (obj);
#line 1804 "ProcessWatcher.c"
}

static GType
terminal_process_watcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminalProcessWatcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_process_watcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalProcessWatcher), 0, (GInstanceInitFunc) terminal_process_watcher_instance_init, NULL };
	GType terminal_process_watcher_type_id;
	terminal_process_watcher_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminalProcessWatcher", &g_define_type_info, 0);
	TerminalProcessWatcher_private_offset = g_type_add_instance_private (terminal_process_watcher_type_id, sizeof (TerminalProcessWatcherPrivate));
	return terminal_process_watcher_type_id;
}

GType
terminal_process_watcher_get_type (void)
{
	static volatile gsize terminal_process_watcher_type_id__once = 0;
	if (g_once_init_enter (&terminal_process_watcher_type_id__once)) {
		GType terminal_process_watcher_type_id;
		terminal_process_watcher_type_id = terminal_process_watcher_get_type_once ();
		g_once_init_leave (&terminal_process_watcher_type_id__once, terminal_process_watcher_type_id);
	}
	return terminal_process_watcher_type_id__once;
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

